Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/builder.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1826,9 +2191,10 @@
               if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for periodic translation: -T <x> <y> <z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for periodic translation: -T <x> <y> <z>" << endl);
+                performCriticalExit();
               } else {
                 if (ExitFlag == 0) ExitFlag = 1;
                 SaveFlag = true;
-                Log() << Verbose(1) << "Translating all ions periodically by given vector." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Translating all ions periodically by given vector." << endl);
                 for (int i=NDIM;i--;)
                   x.x[i] = atof(argv[argptr+i]);
@@ -1841,9 +2207,10 @@
               if ((argptr >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for scaling: -s <factor_x> [factor_y] [factor_z]" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for scaling: -s <factor_x> [factor_y] [factor_z]" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
                 j = -1;
-                Log() << Verbose(1) << "Scaling all ion positions by factor." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Scaling all ion positions by factor." << endl);
                 factor = new double[NDIM];
                 factor[0] = atof(argv[argptr]);
@@ -1851,8 +2218,9 @@
                 factor[2] = atof(argv[argptr+2]);
                 mol->Scale((const double ** const)&factor);
+                double * const cell_size = World::get()->cell_size;
                 for (int i=0;i<NDIM;i++) {
                   j += i+1;
                   x.x[i] = atof(argv[NDIM+i]);
-                  mol->cell_size[j]*=factor[i];
+                  cell_size[j]*=factor[i];
                 }
                 delete[](factor);
@@ -1864,11 +2232,13 @@
               if ((argptr+5 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for centering in box: -b <xx> <xy> <xz> <yy> <yz> <zz>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for centering in box: -b <xx> <xy> <xz> <yy> <yz> <zz>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
                 j = -1;
-                Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl);
+                double * const cell_size = World::get()->cell_size;
                 for (int i=0;i<6;i++) {
-                  mol->cell_size[i] = atof(argv[argptr+i]);
+                  cell_size[i] = atof(argv[argptr+i]);
                 }
                 // center
@@ -1881,11 +2251,13 @@
               if ((argptr+5 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for bounding in box: -B <xx> <xy> <xz> <yy> <yz> <zz>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for bounding in box: -B <xx> <xy> <xz> <yy> <yz> <zz>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
                 j = -1;
-                Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl);
+                double * const cell_size = World::get()->cell_size;
                 for (int i=0;i<6;i++) {
-                  mol->cell_size[i] = atof(argv[argptr+i]);
+                  cell_size[i] = atof(argv[argptr+i]);
                 }
                 // center
@@ -1898,9 +2270,10 @@
               if ((argptr+2 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for centering with boundary: -c <boundary_x> <boundary_y> <boundary_z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for centering with boundary: -c <boundary_x> <boundary_y> <boundary_z>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
                 j = -1;
-                Log() << Verbose(1) << "Centering atoms in config file within given additional boundary." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given additional boundary." << endl);
                 // make every coordinate positive
                 mol->CenterEdge(&x);
@@ -1908,9 +2281,10 @@
                 mol->SetBoxDimension(&x);
                 // translate each coordinate by boundary
+                double * const cell_size = World::get()->cell_size;
                 j=-1;
                 for (int i=0;i<NDIM;i++) {
                   j += i+1;
                   x.x[i] = atof(argv[argptr+i]);
-                  mol->cell_size[j] += x.x[i]*2.;
+                  cell_size[j] += x.x[i]*2.;
                 }
                 mol->Translate((const Vector *)&x);
@@ -1921,5 +2295,5 @@
               if (ExitFlag == 0) ExitFlag = 1;
               SaveFlag = true;
-              Log() << Verbose(1) << "Centering atoms on edge and setting box dimensions." << endl;
+              DoLog(1) && (Log() << Verbose(1) << "Centering atoms on edge and setting box dimensions." << endl);
               x.Zero();
               mol->CenterEdge(&x);
@@ -1931,8 +2305,9 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])))  {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for removing atoms: -r <id>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for removing atoms: -r <id>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
-                Log() << Verbose(1) << "Removing atom " << argv[argptr] << "." << endl;
+                DoLog(1) && (Log() << Verbose(1) << "Removing atom " << argv[argptr] << "." << endl);
                 atom *first = mol->FindAtom(atoi(argv[argptr]));
                 mol->RemoveAtom(first);
@@ -1944,16 +2319,17 @@
               if ((argptr+1 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1]))) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments for fragmentation: -f <max. bond distance> <bond order>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments for fragmentation: -f <max. bond distance> <bond order>" << endl);
+                performCriticalExit();
               } else {
-                Log() << Verbose(0) << "Fragmenting molecule with bond distance " << argv[argptr] << " angstroem, order of " << argv[argptr+1] << "." << endl;
-                Log() << Verbose(0) << "Creating connection matrix..." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with bond distance " << argv[argptr] << " angstroem, order of " << argv[argptr+1] << "." << endl);
+                DoLog(0) && (Log() << Verbose(0) << "Creating connection matrix..." << endl);
                 start = clock();
                 mol->CreateAdjacencyList(atof(argv[argptr++]), configuration.GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
-                Log() << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl);
                 if (mol->first->next != mol->last) {
                   ExitFlag = mol->FragmentMolecule(atoi(argv[argptr]), &configuration);
                 }
                 end = clock();
-                Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl);
                 argptr+=2;
               }
@@ -1963,12 +2339,12 @@
               j = atoi(argv[argptr++]);
               if ((j<0) || (j>1)) {
-                eLog() << Verbose(1) << "ERROR: Argument of '-m' should be either 0 for no-rotate or 1 for rotate." << endl;
+                DoeLog(1) && (eLog()<< Verbose(1) << "Argument of '-m' should be either 0 for no-rotate or 1 for rotate." << endl);
                 j = 0;
               }
               if (j) {
                 SaveFlag = true;
-                Log() << Verbose(0) << "Converting to prinicipal axis system." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Converting to prinicipal axis system." << endl);
               } else
-                Log() << Verbose(0) << "Evaluating prinicipal axis." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Evaluating prinicipal axis." << endl);
               mol->PrincipalAxisSystem((bool)j);
               break;
@@ -1977,11 +2353,12 @@
               if ((argptr+1 >= argc) || (argv[argptr][0] == '-')){
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for convex envelope: -o <convex output file> <non-convex output file>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for convex envelope: -o <convex output file> <non-convex output file>" << endl);
+                performCriticalExit();
               } else {
                 class Tesselation *TesselStruct = NULL;
                 const LinkedCell *LCList = NULL;
-                Log() << Verbose(0) << "Evaluating volume of the convex envelope.";
-                Log() << Verbose(1) << "Storing tecplot convex data in " << argv[argptr] << "." << endl;
-                Log() << Verbose(1) << "Storing tecplot non-convex data in " << argv[argptr+1] << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Evaluating volume of the convex envelope.");
+                DoLog(1) && (Log() << Verbose(1) << "Storing tecplot convex data in " << argv[argptr] << "." << endl);
+                DoLog(1) && (Log() << Verbose(1) << "Storing tecplot non-convex data in " << argv[argptr+1] << "." << endl);
                 LCList = new LinkedCell(mol, 10.);
                 //FindConvexBorder(mol, LCList, argv[argptr]);
@@ -1990,6 +2367,6 @@
                 double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, argv[argptr]);
                 double clustervolume = VolumeOfConvexEnvelope(TesselStruct, &configuration);
-                Log() << Verbose(0) << "The tesselated volume area is " << clustervolume << " " << (configuration.GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl;
-                Log() << Verbose(0) << "The non-convex tesselated volume area is " << clustervolume-volumedifference << " " << (configuration.GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "The tesselated volume area is " << clustervolume << " " << (configuration.GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl);
+                DoLog(0) && (Log() << Verbose(0) << "The non-convex tesselated volume area is " << clustervolume-volumedifference << " " << (configuration.GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3." << endl);
                 delete(TesselStruct);
                 delete(LCList);
@@ -2001,9 +2378,9 @@
               if ((argptr+1 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for suspension with specified volume: -U <volume> <density>" << endl;
-                volume = -1; // for case 'u': don't print error again
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for suspension with specified volume: -U <volume> <density>" << endl);
+                performCriticalExit();
               } else {
                 volume = atof(argv[argptr++]);
-                Log() << Verbose(0) << "Using " << volume << " angstrom^3 as the volume instead of convex envelope one's." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Using " << volume << " angstrom^3 as the volume instead of convex envelope one's." << endl);
               }
             case 'u':
@@ -2012,12 +2389,13 @@
                 if (volume != -1)
                   ExitFlag = 255;
-                  eLog() << Verbose(0) << "Not enough arguments given for suspension: -u <density>" << endl;
+                  DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for suspension: -u <density>" << endl);
+                  performCriticalExit();
               } else {
                 double density;
                 SaveFlag = true;
-                Log() << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.";
+                DoLog(0) && (Log() << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.");
                 density = atof(argv[argptr++]);
                 if (density < 1.0) {
-                  eLog() << Verbose(0) << "Density must be greater than 1.0g/cm^3 !" << endl;
+                  DoeLog(1) && (eLog()<< Verbose(1) << "Density must be greater than 1.0g/cm^3 !" << endl);
                   density = 1.3;
                 }
@@ -2025,5 +2403,5 @@
 //                  repetition[i] = atoi(argv[argptr++]);
 //                  if (repetition[i] < 1)
-//                    eLog() << Verbose(0) << "ERROR: repetition value must be greater 1!" << endl;
+//                    DoeLog(1) && (eLog()<< Verbose(1) << "repetition value must be greater 1!" << endl);
 //                  repetition[i] = 1;
 //                }
@@ -2035,7 +2413,9 @@
               if ((argptr+2 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for repeating cells: -d <repeat_x> <repeat_y> <repeat_z>" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for repeating cells: -d <repeat_x> <repeat_y> <repeat_z>" << endl);
+                performCriticalExit();
               } else {
                 SaveFlag = true;
+                double * const cell_size = World::get()->cell_size;
                 for (int axis = 1; axis <= NDIM; axis++) {
                   int faktor = atoi(argv[argptr++]);
@@ -2044,5 +2424,5 @@
                   Vector ** vectors;
                   if (faktor < 1) {
-                    eLog() << Verbose(0) << "ERROR: Repetition faktor mus be greater than 1!" << endl;
+                    DoeLog(1) && (eLog()<< Verbose(1) << "Repetition factor mus be greater than 1!" << endl);
                     faktor = 1;
                   }
@@ -2061,8 +2441,8 @@
                     }
                     if (count != j)
-                      Log() << Verbose(0) << "ERROR: AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl;
+                      DoeLog(1) && (eLog()<< Verbose(1) << "AtomCount " << count << " is not equal to number of atoms in molecule " << j << "!" << endl);
                     x.Zero();
                     y.Zero();
-                    y.x[abs(axis)-1] = mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
+                    y.x[abs(axis)-1] = cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] * abs(axis)/axis; // last term is for sign, first is for magnitude
                     for (int i=1;i<faktor;i++) {  // then add this list with respective translation factor times
                       x.AddVector(&y); // per factor one cell width further
@@ -2085,5 +2465,5 @@
                       mol->Translate(&x);
                     }
-                    mol->cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
+                    cell_size[(abs(axis) == 2) ? 2 : ((abs(axis) == 3) ? 5 : 0)] *= faktor;
                   }
                 }
@@ -2102,7 +2482,7 @@
   } else {  // no arguments, hence scan the elements db
     if (periode->LoadPeriodentafel(configuration.databasepath))
-      Log() << Verbose(0) << "Element list loaded successfully." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Element list loaded successfully." << endl);
     else
-      Log() << Verbose(0) << "Element list loading failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Element list loading failed." << endl);
     configuration.RetrieveConfigPathAndName("main_pcp_linux");
   }
@@ -2126,5 +2506,10 @@
   int j;
 
-  setVerbosity(2);
+  cout << ESPACKVersion << endl;
+
+  DoLog(1) && (Log() << Verbose(1) << "test" << endl);
+  DoLog(3) && (Log() << Verbose(1) << "test");
+
+  setVerbosity(0);
 
   // =========================== PARSE COMMAND LINE OPTIONS ====================================
@@ -2152,9 +2537,10 @@
   if (molecules->ListOfMolecules.size() == 0) {
     mol = new molecule(periode);
-    if (mol->cell_size[0] == 0.) {
-      Log() << Verbose(0) << "enter lower tridiagonal form of basis matrix" << endl << endl;
+    double * const cell_size = World::get()->cell_size;
+    if (cell_size[0] == 0.) {
+      DoLog(0) && (Log() << Verbose(0) << "enter lower tridiagonal form of basis matrix" << endl << endl);
       for (int i=0;i<6;i++) {
-        Log() << Verbose(1) << "Cell size" << i << ": ";
-        cin >> mol->cell_size[i];
+        DoLog(1) && (Log() << Verbose(1) << "Cell size" << i << ": ");
+        cin >> cell_size[i];
       }
     }
@@ -2166,23 +2552,23 @@
 
   // now the main construction loop
-  Log() << Verbose(0) << endl << "Now comes the real construction..." << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl << "Now comes the real construction..." << endl);
   do {
-    Log() << Verbose(0) << endl << endl;
-    Log() << Verbose(0) << "============Molecule list=======================" << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl << endl);
+    DoLog(0) && (Log() << Verbose(0) << "============Molecule list=======================" << endl);
     molecules->Enumerate((ofstream *)&cout);
-    Log() << Verbose(0) << "============Menu===============================" << endl;
-    Log() << Verbose(0) << "a - set molecule (in)active" << endl;
-    Log() << Verbose(0) << "e - edit molecules (load, parse, save)" << endl;
-    Log() << Verbose(0) << "g - globally manipulate atoms in molecule" << endl;
-    Log() << Verbose(0) << "M - Merge molecules" << endl;
-    Log() << Verbose(0) << "m - manipulate atoms" << endl;
-    Log() << Verbose(0) << "-----------------------------------------------" << endl;
-    Log() << Verbose(0) << "c - edit the current configuration" << endl;
-    Log() << Verbose(0) << "-----------------------------------------------" << endl;
-    Log() << Verbose(0) << "s - save current setup to config file" << endl;
-    Log() << Verbose(0) << "T - call the current test routine" << endl;
-    Log() << Verbose(0) << "q - quit" << endl;
-    Log() << Verbose(0) << "===============================================" << endl;
-    Log() << Verbose(0) << "Input: ";
+    DoLog(0) && (Log() << Verbose(0) << "============Menu===============================" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "a - set molecule (in)active" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "e - edit molecules (load, parse, save)" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "g - globally manipulate atoms in molecule" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "M - Merge molecules" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "m - manipulate atoms" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "-----------------------------------------------" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "c - edit the current configuration" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "-----------------------------------------------" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "s - save current setup to config file" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "T - call the current test routine" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "q - quit" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "Input: ");
     cin >> choice;
 
@@ -2190,5 +2576,5 @@
       case 'a':  // (in)activate molecule
         {
-          Log() << Verbose(0) << "Enter index of molecule: ";
+          DoLog(0) && (Log() << Verbose(0) << "Enter index of molecule: ");
           cin >> j;
           for(MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
@@ -2236,7 +2622,7 @@
   // save element data base
   if (periode->StorePeriodentafel(configuration->databasepath)) //ElementsFileName
-    Log() << Verbose(0) << "Saving of elements.db successful." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Saving of elements.db successful." << endl);
   else
-    Log() << Verbose(0) << "Saving of elements.db failed." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Saving of elements.db failed." << endl);
 
   delete(molecules); // also free's all molecules contained
